#ifndef _OcclusionCullingDotSceneManager_H__
#define _OcclusionCullingDotSceneManager_H__

#include "OgreSceneNode.h"
#include "DotSceneManager.h"
#include "OgreOcclusionCullingSceneTraverser.h"

#include "OgrePrerequisites.h"

using namespace std;

namespace Ogre {
	
	/**
		Class which implements a scene mangager which uses occlusion queries for culling occluded objects
	*/
	class OcclusionCullingDotSceneManager: public DotSceneManager
	{
	public:
		OcclusionCullingDotSceneManager();
		~OcclusionCullingDotSceneManager();
	
		void _renderVisibleObjects(void);
		void _findVisibleObjects(Camera* cam, bool onlyShadowCasters);
		void _updateSceneGraph(Camera* cam);

		/** Sets the given option for the SceneManager
			       @remarks
			Options are:
			"Algorithm", int *;			
		*/
		virtual bool setOption( const String &, const void * );
		/** Gets the given option for the Scene Manager.
	        @remarks
		    See setOption
		*/
		virtual bool getOption( const String &, void * );

		bool getOptionValues( const String & key, StringVector &refValueList );
		bool getOptionKeys( StringVector &refKeys );

	protected:
		OcclusionCullingSceneTraverser *mOcclusionCullingSceneTraverser;
	};

}
#endif // OcclusionCullingDotSceneManager_H
